%global commitId 91530fdb0c46b6c0d843a6430016d9d5e7b56213

%global stable_version 1.18.0
%global stable_distinfo %{stable_version}.dist-info
%global prerel_version 0.39b0
%global prerel_distinfo %{prerel_version}.dist-info

%global stable_pkgdirs %{shrink:
    exporter/opentelemetry-exporter-otlp
    exporter/opentelemetry-exporter-otlp-proto-common
    exporter/opentelemetry-exporter-otlp-proto-grpc
    exporter/opentelemetry-exporter-otlp-proto-http
    opentelemetry-api
    opentelemetry-sdk
    opentelemetry-proto}

%global prerel_pkgdirs %{shrink:
    opentelemetry-semantic-conventions}

%if 0%{?rhel} == 8
%global component_prefix 3x
%endif

Name:           python%{?component_prefix}-opentelemetry
Version:        %{stable_version}
Release:        1%{?dist}
Summary:        OpenTelemetry Python API and SDK

License:        Apache-2.0
URL:            https://github.com/open-telemetry/opentelemetry-python
Source0:        opentelemetry-python-91530fdb0c46b6c0d843a6430016d9d5e7b56213.tar.gz
BuildArch:      noarch

BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:  python%{python3_pkgversion}-hatchling
BuildRequires:  python%{python3_pkgversion}-pip
BuildRequires:  python%{python3_pkgversion}-rpm-macros

%description
%{summary}


%package -n python%{python3_pkgversion}-opentelemetry-exporter-otlp
Summary:        OpenTelemetry Collector Exporters
Version:        %{version}

# Dependencies across subpackages should be fully-versioned.
Requires:       python%{python3_pkgversion}-opentelemetry-exporter-otlp-proto-grpc = %{version}-%{release}
Requires:       python%{python3_pkgversion}-opentelemetry-exporter-otlp-proto-http = %{version}-%{release}

%description -n python%{python3_pkgversion}-opentelemetry-exporter-otlp
This library is provided as a convenience to install all supported
OpenTelemetry Collector Exporters. Currently it installs:

  • opentelemetry-exporter-otlp-proto-grpc
  • opentelemetry-exporter-otlp-proto-http

In the future, additional packages will be available:

  • opentelemetry-exporter-otlp-json-http

To avoid unnecessary dependencies, users should install the specific package
once they’ve determined their preferred serialization and protocol method.


%package -n python%{python3_pkgversion}-opentelemetry-exporter-otlp-proto-common
Summary:        OpenTelemetry Protobuf Encoding

Requires:       python%{python3_pkgversion}-opentelemetry-proto = %{version}-%{release}

%description -n python%{python3_pkgversion}-opentelemetry-exporter-otlp-proto-common
This library is provided as a convenience to encode to Protobuf. Currently used
by:

  • opentelemetry-exporter-otlp-proto-grpc
  • opentelemetry-exporter-otlp-proto-http


%package -n python%{python3_pkgversion}-opentelemetry-exporter-otlp-proto-grpc
Summary:        OpenTelemetry Collector Protobuf over gRPC Exporter

Requires:       python%{python3_pkgversion}-deprecated >= 1.2.6
Requires:       python%{python3_pkgversion}-backoff >= 1.10.0
Requires:       python%{python3_pkgversion}-backoff < 3.0.0
Requires:       python%{python3_pkgversion}-googleapis-common-protos >= 1.52
Requires:       python%{python3_pkgversion}-googleapis-common-protos < 2
Requires:       python%{python3_pkgversion}-grpcio >= 1.0.0
Requires:       python%{python3_pkgversion}-grpcio < 2.0.0
Requires:       python%{python3_pkgversion}-opentelemetry-api >= 1.15
Requires:       python%{python3_pkgversion}-opentelemetry-api < 2
Requires:       python%{python3_pkgversion}-opentelemetry-sdk = %{version}-%{release}
Requires:       python%{python3_pkgversion}-opentelemetry-proto = %{version}-%{release}
Requires:       python%{python3_pkgversion}-opentelemetry-exporter-otlp-proto-common = %{version}-%{release}

%description -n python%{python3_pkgversion}-opentelemetry-exporter-otlp-proto-grpc
This library allows to export data to the OpenTelemetry Collector using the
OpenTelemetry Protocol using Protobuf over gRPC.


%package -n python%{python3_pkgversion}-opentelemetry-exporter-otlp-proto-http
Summary:        OpenTelemetry Collector Protobuf over HTTP Exporter
Version:        %{version}

Requires:       python%{python3_pkgversion}-deprecated >= 1.2.6
Requires:       python%{python3_pkgversion}-backoff >= 1.10.0
Requires:       python%{python3_pkgversion}-backoff < 3.0.0
Requires:       python%{python3_pkgversion}-googleapis-common-protos >= 1.52
Requires:       python%{python3_pkgversion}-googleapis-common-protos < 2
Requires:       python%{python3_pkgversion}-opentelemetry-api >= 1.15
Requires:       python%{python3_pkgversion}-opentelemetry-api < 2
Requires:       python%{python3_pkgversion}-opentelemetry-sdk = %{version}-%{release}
Requires:       python%{python3_pkgversion}-opentelemetry-proto = %{version}-%{release}
Requires:       python%{python3_pkgversion}-opentelemetry-exporter-otlp-proto-common = %{version}-%{release}
Requires:       python%{python3_pkgversion}-requests >= 2.7
Requires:       python%{python3_pkgversion}-requests < 3

%description -n python%{python3_pkgversion}-opentelemetry-exporter-otlp-proto-http
This library allows to export data to the OpenTelemetry Collector using the
OpenTelemetry Protocol using Protobuf over HTTP.


%package -n python%{python3_pkgversion}-opentelemetry-api
Summary:        OpenTelemetry Python API

Requires:       python%{python3_pkgversion}-deprecated >= 1.2.6
Requires:       python%{python3_pkgversion}-setuptools >= 16.0
Requires:       python%{python3_pkgversion}-importlib-metadata >= 6.0.0
Requires:       python%{python3_pkgversion}-importlib-metadata < 6.1

%description -n python%{python3_pkgversion}-opentelemetry-api
%{summary}.


%package -n python%{python3_pkgversion}-opentelemetry-proto
Summary:        OpenTelemetry Python Proto

Requires:       python%{python3_pkgversion}-protobuf >= 3.19
Requires:       python%{python3_pkgversion}-protobuf < 5.0

%description -n python%{python3_pkgversion}-opentelemetry-proto
%{summary}.


%package -n python%{python3_pkgversion}-opentelemetry-sdk
Summary:        OpenTelemetry Python SDK

Requires:       python%{python3_pkgversion}-opentelemetry-api = %{version}-%{release}
Requires:       python%{python3_pkgversion}-opentelemetry-semantic-conventions = %{prerel_version}-%{release}
Requires:       python%{python3_pkgversion}-setuptools >= 16.0
Requires:       python%{python3_pkgversion}-typing-extensions >= 3.7.4

%description -n python%{python3_pkgversion}-opentelemetry-sdk
%{summary}.


%package -n python%{python3_pkgversion}-opentelemetry-semantic-conventions
Summary:        OpenTelemetry Python Semantic Conventions
Version:        %{prerel_version}

%description -n python%{python3_pkgversion}-opentelemetry-semantic-conventions
This library contains generated code for the semantic conventions defined by
the OpenTelemetry specification.


%prep
%autosetup -n opentelemetry-python-%{commitId}

%build
for pkgdir in %{stable_pkgdirs} %{prerel_pkgdirs}
do
  pushd "${pkgdir}"
    %{__python3} -m pip wheel --wheel-dir %{_builddir}/wheeldir --no-deps --use-pep517 --no-build-isolation --disable-pip-version-check --no-clean --progress-bar off --verbose .
  popd
done

%install
for pkgdir in %{stable_pkgdirs} %{prerel_pkgdirs}
do
  module_name=${pkgdir#*/}
  if [[ "%{stable_pkgdirs}" == *"${pkgdir}"* ]]; then module_version=%{stable_version}; else module_version=%{prerel_version}; fi
  pushd "${pkgdir}"
    %{__python3} -m pip install --root %{buildroot} --no-deps --disable-pip-version-check --progress-bar off --verbose --ignore-installed --no-warn-script-location --no-index --no-cache-dir --find-links %{_builddir}/wheeldir ${module_name}==${module_version}
  popd
  for distinfo in %{buildroot}/%{python3_sitelib}/*.dist-info
  do
    sed -i 's/pip/rpm/' ${distinfo}/INSTALLER
    rm -fv ${distinfo}/{RECORD,REQUESTED}
  done
done


%files -n python%{python3_pkgversion}-opentelemetry-exporter-otlp-proto-common
# Note that the contents are identical to the top-level LICENSE file.
%license exporter/opentelemetry-exporter-otlp-proto-common/LICENSE
%doc exporter/opentelemetry-exporter-otlp-proto-common/README.rst

# Shared namespace directories
%dir %{python3_sitelib}/opentelemetry/
%{python3_sitelib}/opentelemetry/py.typed
%dir %{python3_sitelib}/opentelemetry/exporter/
%dir %{python3_sitelib}/opentelemetry/exporter/otlp/
%{python3_sitelib}/opentelemetry/exporter/otlp/py.typed
%dir %{python3_sitelib}/opentelemetry/exporter/otlp/proto/

%{python3_sitelib}/opentelemetry/exporter/otlp/proto/common/
%{python3_sitelib}/opentelemetry_exporter_otlp_proto_common-%{stable_distinfo}/


%files -n python%{python3_pkgversion}-opentelemetry-exporter-otlp-proto-grpc
# Note that the contents are identical to the top-level LICENSE file.
%license exporter/opentelemetry-exporter-otlp-proto-grpc/LICENSE
%doc exporter/opentelemetry-exporter-otlp-proto-grpc/README.rst

# Shared namespace directories
%dir %{python3_sitelib}/opentelemetry/
%{python3_sitelib}/opentelemetry/py.typed
%dir %{python3_sitelib}/opentelemetry/exporter/
%dir %{python3_sitelib}/opentelemetry/exporter/otlp/
%{python3_sitelib}/opentelemetry/exporter/otlp/py.typed
%dir %{python3_sitelib}/opentelemetry/exporter/otlp/proto/

%{python3_sitelib}/opentelemetry/exporter/otlp/proto/grpc/
%{python3_sitelib}/opentelemetry_exporter_otlp_proto_grpc-%{stable_distinfo}/


%files -n python%{python3_pkgversion}-opentelemetry-exporter-otlp-proto-http
# Note that the contents are identical to the top-level LICENSE file.
%license exporter/opentelemetry-exporter-otlp-proto-http/LICENSE
%doc exporter/opentelemetry-exporter-otlp-proto-http/README.rst

# Shared namespace directories
%dir %{python3_sitelib}/opentelemetry
%{python3_sitelib}/opentelemetry/py.typed
%dir %{python3_sitelib}/opentelemetry/exporter/
%dir %{python3_sitelib}/opentelemetry/exporter/otlp/
%dir %{python3_sitelib}/opentelemetry/exporter/otlp/proto/
%{python3_sitelib}/opentelemetry/exporter/otlp/py.typed

%{python3_sitelib}/opentelemetry/exporter/otlp/proto/http/
%{python3_sitelib}/opentelemetry_exporter_otlp_proto_http-%{stable_distinfo}/


%files -n python%{python3_pkgversion}-opentelemetry-exporter-otlp
# Note that the contents are identical to the top-level LICENSE file.
%license exporter/opentelemetry-exporter-otlp/LICENSE
%doc exporter/opentelemetry-exporter-otlp/README.rst

# Shared namespace directories are already (co)-owned by the implementation
# subpackages (-proto-grpc, -proto-http) upon which this subpackage depends.

%dir %{python3_sitelib}/opentelemetry/exporter/otlp/__pycache__/
%pycached %{python3_sitelib}/opentelemetry/exporter/otlp/version.py
%{python3_sitelib}/opentelemetry_exporter_otlp-%{stable_distinfo}/


%files -n python%{python3_pkgversion}-opentelemetry-api
# Note that the contents are identical to the top-level LICENSE file.
%license opentelemetry-api/LICENSE
%doc opentelemetry-api/README.rst

# Shared namespace directories
%dir %{python3_sitelib}/opentelemetry/
%{python3_sitelib}/opentelemetry/py.typed
%dir %{python3_sitelib}/opentelemetry/propagators/

%{python3_sitelib}/opentelemetry/_logs/
%{python3_sitelib}/opentelemetry/attributes/
%{python3_sitelib}/opentelemetry/baggage/
%{python3_sitelib}/opentelemetry/context/
%{python3_sitelib}/opentelemetry/metrics/
%{python3_sitelib}/opentelemetry/propagate/
%dir %{python3_sitelib}/opentelemetry/propagators/__pycache__/
%pycached %{python3_sitelib}/opentelemetry/propagators/composite.py
%pycached %{python3_sitelib}/opentelemetry/propagators/textmap.py
%{python3_sitelib}/opentelemetry/trace/
%{python3_sitelib}/opentelemetry/util/
%dir %{python3_sitelib}/opentelemetry/__pycache__/
%pycached %{python3_sitelib}/opentelemetry/environment_variables.py
%pycached %{python3_sitelib}/opentelemetry/version.py
%{python3_sitelib}/opentelemetry_api-%{stable_distinfo}/


%files -n python%{python3_pkgversion}-opentelemetry-proto
# Note that the contents are identical to the top-level LICENSE file.
%license opentelemetry-proto/LICENSE
%doc opentelemetry-proto/README.rst

# Shared namespace directories
%dir %{python3_sitelib}/opentelemetry/
%{python3_sitelib}/opentelemetry/py.typed

%{python3_sitelib}/opentelemetry/proto/
%{python3_sitelib}/opentelemetry_proto-%{stable_distinfo}/


%files -n python%{python3_pkgversion}-opentelemetry-sdk
# Note that the contents are identical to the top-level LICENSE file.
%license opentelemetry-sdk/LICENSE
%doc opentelemetry-sdk/README.rst

# Shared namespace directories
%dir %{python3_sitelib}/opentelemetry/
%{python3_sitelib}/opentelemetry/py.typed

%{python3_sitelib}/opentelemetry/sdk/
%{python3_sitelib}/opentelemetry_sdk-%{stable_distinfo}/


%files -n python%{python3_pkgversion}-opentelemetry-semantic-conventions
# Note that the contents are identical to the top-level LICENSE file.
%license opentelemetry-semantic-conventions/LICENSE
%doc opentelemetry-semantic-conventions/README.rst

# Shared namespace directories
%dir %{python3_sitelib}/opentelemetry/
%{python3_sitelib}/opentelemetry/py.typed

%{python3_sitelib}/opentelemetry/semconv/
%{python3_sitelib}/opentelemetry_semantic_conventions-%{prerel_distinfo}/

%changelog
* Mon Jul 10 2023 Satoe Imaishi <simaishi@redhat.com> - 1.18.0-1
- Initial Build
